# 
# April 2009 -  Merge DA
#    based on GREAT/LYRTECH

set frametitle "MIDAS Merge Control"

set VERSION "MERGE"


set LYRTECHPresent 0

if {$LYRTECHPresent} {
  set VARIANT "LYRTECH"
  set frametitle "MIDAS Merge (& LyrTech) Control"
}


set env(RDOUThdwre) Merge
set env(RDOUTserver) merge

set DAProgram "Unavailable (master)"
set LinuxDirectory /MIDAS/Merge/MergeServer

loadsource sys.common
if {$LYRTECHPresent} {
  loadsource lyrtech
} else {
      proc LyrTech_Stop {} {}
      proc LyrTech_Go {} {}
      proc LyrTech_Setup v {}
      proc LyrTech_Reset v {}
      proc LyrTech_ReadState {} {return -1}
}

insert-debug "RDOUTserver is $RDOUTserver"

set CAMACPresent 0
set VMEPresent 0
set VXIPresent 0

set CAMACEnable 0
set VMEEnable 0
set VXIEnable 0

set LYRTECHEnable 0

set X2VBPresent 0

set RDOUTEnable 1

set TSPresent 1
set EBPresent 1

set TSEnable 0

set histPresent 1
set histEnable 1

set NamesPres 0
set Names {}

set txEnable 0
set ebtxEnable 0

if {[info exists env(RDOUThdwre)] == 0} then {set hdwre Merge} else {set hdwre $env(RDOUThdwre)}
set RDOUThdwre $hdwre

set POLLTICKS 100000


set DelayTicks 6

#    append to common lists

lappend registerlist [list NetVar.DACQ.Chistmode	generic  "-nDACQ_HistMode -tint"]
lappend registerlist [list NetVar.DACQ.CPileupRate	generic  "-nDACQ_PileupRate -tint"]
lappend registerlist [list NetVar.DACQ.InitialTimeStamp	generic  "-nMerge_InitialTimeStamp -tuint"]
lappend registerlist [list NetVar.DACQ.Spaused          generic  "-nMerge_IsPaused -tint"]
lappend registerlist [list NetVar.DACQ.StatsArray       generic  "-n DACQ_Stats -t int -a yes -i 0 -l 64"]
lappend registerlist [list NetVar.DACQ.RatesArray       generic  "-n DACQ_Rates -t int -a yes -i 0 -l 64"]
lappend registerlist [list NetVar.DACQ.OutputTraces     generic  "-nMerge_OutputTrace -tint"]
lappend registerlist [list NetVar.DACQ.KeepNonMonotonic generic  "-nMerge_KeepNonMonotonic -tint"]
lappend registerlist [list NetVar.DACQ.StartFromZero    generic  "-nMerge_StartFromZero -tint"]
lappend registerlist [list NetVar.DACQ.DontUseSyncs     generic  "-nMerge_DontUseSyncs -tint"]
lappend registerlist [list NetVar.DACQ.TimeOrderWindow  generic  "-nMerge_TimeOrderWindow -tint"]
lappend registerlist [list NetVar.DACQ.GREATWordOrder   generic  "-nDACQ_GREATWordOrder -tint"]
lappend registerlist [list NetVar.DACQ.SyncBits         generic  "-nMerge_SyncBits -tint"]

lappend setuplist [list "Force Spectrum Map" "map_needed"]

set SetupMessage "\n\
Are you sure you wish to SETUP the data acquisition system?\n\n\
SETUP will STOP data acquisition.\n\
Configure the VXI Control software and restore VXI parameter settings.\n\
It will also recreate all histograms selected.\n\
This may take several minutes.\n\n\
If you decide to continue please wait for the SETUP sequence to complete and DO NOT touch the system while it is in progress.
"

proc Set_Options {} {
    global Options

    load_Options

    Set_Common_Options

    update_Options
}


proc map_needed {} {
   global RDOUTEnable VXIPresent LYRTECHPresent

   if {$RDOUTEnable == 0} then {return}

   write-register NetVar.DACQ.Cspectramapped 0
}

proc delete_spectra {} {
   global SpectrumServer
}

proc create_spectra {} {
    global SpectrumServer Options

   set range $Options(Stat.channels)
   set z [catch {eg "(spectrum :path '/$SpectrumServer' :range $range :name 'Stat' !new)" } m]
   map_spectrum "Stat 0"

   set range $Options(Rate.channels)
   set z [catch {eg "(spectrum :path '/$SpectrumServer' :range $range :name 'Rate' !new)" } m]
   
#     all other spectra created by the software histogram interface
    map_spectra
}

proc map_spectra {} {
   global EGreport env
   global RDOUTEnable

   if {$RDOUTEnable == 0} then {return}
   
   if {[map_?_needed] == 1} then {return}
   
#   inform shist start
#   inform shist close-frame

   set EGreport_SAVE $EGreport
   set EGreport -1
   
   set-footer "mapping spectra"
   set-busy

   set l [spectra-names]
   set n 0
   foreach item $l {
       set name [second $item]
#       set Xname [inform shist Give_XlateR $name]
       set Xname $name
       set module [first [split $Xname .]]
       set adc    [second [split $Xname .]]
       set m [second [split $module #]]
       set a [string range $adc 3 end]
       if {"[first [split $module #]]" == "tdr32v"} then {
          map_spectrum "$name [expr ($m << 5) + $a]"
       }
   }

   map_not_needed

   set EGreport $EGreport_SAVE

   clear-busy
   set-footer "mapped [llength $l] spectra"
}

proc checkinstallation  {} {
   global OS VERSION env

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return 0}

   set ID [read-register NetVar.Executive.ID]
   if {[llength $ID] != 3} then {set ID [read-register NetVar.EXEC.ID]}

   set OS [first $ID]

   set ID [read-register NetVar.EXEC.ID]

   set version  [second $ID]
   set release [third $ID]

   if {$version != $VERSION && $release != [string totitle $VERSION]} then {
       set msg " WARNING!  Possible system installation or setup error! \n\
       Require Data Acquisition program $VERSION but discovered \n\
       OS $OS; Program $version; Release $release\n\
       Do you wish to continue?"
       if {[midas-confirmation $msg] == 0} then {return 1}
   }

   set env(RTOS) $OS
   return 0
}

proc click-rdout  {v} {
    global POLLTICKS

   global RDOUThdwre RDOUTEnable; if {$RDOUTEnable == 0} then {return}

    set z [catch {
        if {$v==0} then {
#    Halt
              after cancel Check-DA
              execute-command 1 "Halt"
              after 6000 inform MergeLinks display-Merge
        }
        if {$v==1} then {
#    Go
              map_spectra

              execute-command 2 "Go"
              after 5000 Check-DA
              after 6000 inform MergeLinks display-Merge
              
        }
        if {$v==2} then {
#    Setup

              Poll_Ticks $POLLTICKS
              
              after cancel Check-DA
              execute-command 3 "Setup"

              after 1000
              catch {inform MergeLinks :query_Mapped} isMapped
              inform MergeLinks do_setup
              if {$isMapped!=1} {inform MergeLinks close-frame}
        }
        if {$v==3} then {
#    Reset
              
              after cancel Check-DA
              execute-command 9 "Reset"
        }
        wait_for_completion
    } m ]
    redisplay-rdout
    clear-footer
}

proc click-setup-rdout {arg} {
   global CAMACEnable VMEEnable VXIEnable LYRTECHEnable

# stop DA with currrent settings - probably not necessary
#   click-da 0

# Disable all subsystems
   set Tmp_CAMACEnable $CAMACEnable; set CAMACEnable 0
   set Tmp_VMEEnable $VMEEnable; set VMEEnable 0
   set Tmp_VXIEnable $VXIEnable; set VXIEnable 0
   set Tmp_LYRTECHEnable $LYRTECHEnable; set LYRTECHEnable 0

# Call normal setup - should now  act on rdout (Merge) only
   click-setup $arg

# Reenable subsystems where needed
   set CAMACEnable $Tmp_CAMACEnable
   set VMEEnable $Tmp_VMEEnable
   set VXIEnable $Tmp_VXIEnable
   set LYRTECHEnable $Tmp_LYRTECHEnable

   click-redisplay
}

proc redisplay-rdout {} {
   global RDOUTEnable readoutstate

   if {$RDOUTEnable == 0} then {
      :modify RDOUT :value -1
      :modify PAUSE :value 0
      return
   }
   set readoutstate [expr [read-register NetVar.DACQ.Sstate]-1]
   :modify RDOUT :value $readoutstate

   set pause [read-register NetVar.DACQ.Spaused]
   :modify PAUSE :value $pause

   inform MergeLinks display-Merge
}

proc Custom_PostCheck {arg} {
    catch {inform MergeLinks inquire started} isStarted
    if {$isStarted} {
       catch {inform MergeLinks :query_Mapped} isMapped
    } else {
      set isMapped 0
    }

    inform MergeLinks start
    inform MergeLinks load_configuration
    if {$isMapped!=1} {inform MergeLinks close-frame}
}

set my_opt -1

proc Custom_SetupD {option} {    ;#  opt = 0 setup where needed,  opt = 1  setup everything,  opt = 2  prompt
    upvar opt opt

    set my_opt $option
    set opt 1    ;# will force VXI parameter restore
}

proc Custom_PostSetup {opt} {
   global my_opt

   if {$my_opt == -1} {set my_opt $opt}
   LyrTech_Setup $my_opt
}

# LyrTech needs to be stopped when the synchronize call is made
# so stop it first - just in case it's going
proc Custom_PreGo {} { LyrTech_Stop }

# command 16 is User Application 1  (Merge_start() in Merge DA code)
# tells the merge DA program to allow data through, starting with timestamp
# equal or greater than the metronome re-synch time
# Should be called after Go_Electronics which has invoked the metronome's
# synchronize-all to set up the initial timestamp value for the cards and
# written it to the merge program
# after all that we can tell the lyrtech to start
proc Custom_PostGo {} {

   insert-log "START to Merge"
   click-special 16

   LyrTech_Go
}

# LyrTech needs to be stopped after readout has ended
# when merge is in "sink data" state
# So, some belt & braces - force merge into "Pause" state
# remember click-special 17 is a toggle so read the current state first
proc Custom_PreStop {} {
   set pause [read-register NetVar.DACQ.Spaused]
   if {$pause != 1} then {click-special 17}
}

# LyrTech needs to be stopped after readout has ended
# when merge is in "sink data" state
proc Custom_PostStop {} { LyrTech_Stop }

proc Go_Electronics {} {
   write-register NetVar.DACQ.InitialTimeStamp 0
}

proc Stop_Electronics {} {}

# Don't force a reset (means action is currently a no-op)
proc Reset_Electronics {} { LyrTech_Reset 0 }

# command 17 is User Application 2  (Merge_pause() in Merge DA code)
# This is a toggle.
# if DA is outputting data this tells it to discard data (PAUSE state)
# if DA is discarding data this tells it to restart from the next good
# SYNC pulse or Extended timestamp. Otherwise do nothing.
proc click-pause {v} {
   set pause [read-register NetVar.DACQ.Spaused]
   if {$pause != $v} then {click-special 17}
   redisplay-rdout
   return  [read-register NetVar.DACQ.Spaused]
}

# command 18 is User Application 3  (Merge_restart() in Merge DA code)
# This tells the DA to restart from the original starting timestamp
# similar to stop/start in one command, without touching
# output to TS or EB or input from LyrTech
# it should unblock any stuck queues
# DA state must have been WANT_NEXT_SYNC, READY_FOR_DATA or OUTPUT_PAUSED
# Merge_restart() flushes & resets queues and moves to state WANT_FIRST_SYNC
proc click-restart {} {
   click-special 18
   redisplay-rdout
}

proc click-lyrtech {w vl} {
#insert-debug "Clicked LYRTECH with widget $w, value $vl"
    global debug  LYRTECHEnable

    if {$LYRTECHEnable == 0} then {reshow-lyrtech; return}

    switch $vl {
      0  {LyrTech_Stop}
      1  {LyrTech_Go}
      2  {LyrTech_Setup 1  ;# Setup everything}
      3  {LyrTech_Reset 1  ;# Force a reset}
    }
    redisplay-lyrtech
}

proc click-lyrtechenable {w vl} {
    global debug  LYRTECHEnable
    set LYRTECHEnable $vl
    redisplay-xxxenable
}

proc reshow-lyrtech {} {
   global LYRTECHEnable lyrtechstate

   set-busy

   set lyrtechstate [LyrTech_ReadState]
   :modify LYRTECH :value $lyrtechstate

   clear-busy
}

proc redisplay-lyrtech {} {
   reshow-lyrtech
   after 10000 reshow-lyrtech
   after 15000 reshow-lyrtech
}

proc set-experiment args {LyrTech_Servers}
proc unset-experiment {} {NoLyrTech_Servers}
